#!/bin/perl

# Copyright 2013 CA Technology, Inc. All rights reserved.
# Note: This script creates a metric called "OSResource|Disk:Success"
# The value for this metric is 2 is the script is functioning normally.
# If there is a problem, the value of this metric should be 1 and there
# should be a netstat_errors.log file in the logs directory. This file contains
# some diagnostic information for the problem that this script is experiencing.

# Fix details
# Author                 Date Modified       TT Details    Modification
# ------                 -------------       ----------    --------------------------------
# ghhsi01                15 May 2009         49952         Data format changed from
#                                                          XML format to simple data format 

use Sys::Hostname;
# warnings and strict commented out for the default version of Perl that comes with Solaris 8
# use warnings;
# use strict;
use FindBin;
use lib ("$FindBin::Bin", "$FindBin::Bin/../lib/perl");
use Wily::PrintMetric;

#Header of 'df -k' output on Linux
#Filesystem           1K-blocks      Used Available Use% Mounted on

my $error_log = "./../../logs/disk_errors.log";

eval {
	my $host = hostname;
	$error_log = "./../../logs/disk_errors.${host}.log";

	my $dfcommand = 'df -k|';
        my $firstTime = 1;
	my $fileSystem;
	my $capacity;
	my $freediskspace;
	my $freediskspaceper;
	my $mountedOn;
	my $line_broken=0;

	open(DISK,$dfcommand) || die "Error when executing \"$dfcommand\": $!";

	 while (<DISK>) {
		chomp;
		split;
		if($firstTime) {
			$firstTime = 0;
		 }
		 else{	
			if ($_[1] == NULL) {
				$line_broken=1;
				
			}

		 if($line_broken==0)
		    {		

					$mountedOn = $_[5];
					$mountedOn =~ tr/:/_/;
					
					$useddiskspaceper = $_[4];
					#$useddiskspaceper = chop($useddiskspaceper);
					$freediskspaceper = 100 - $useddiskspaceper ;
					$freediskspace = int($_[3]/1024);
					
					if ($_[3] != '-'){

							Wily::PrintMetric::printMetric( type        => 'IntCounter',
												resource    => 'OSResource-Linux|Disk',
													subresource => $mountedOn,
														name        => 'Free Disk Space (MB)',
														value       => $freediskspace,
												 );
								Wily::PrintMetric::printMetric( type        => 'IntCounter',
												resource    => 'OSResource-Linux|Disk',
													subresource => $mountedOn,
														name        => 'Free Disk Space (%)',
														value       => $freediskspaceper,
													);

							         }

			  }
			  if(($line_broken==1)&&($_[1] != NULL))
				 {
							$line_broken=0;
							$mountedOn = $_[4];
							$mountedOn =~ tr/:/_/;
							
							$useddiskspaceper = $_[3];
							#$useddiskspaceper = chop($useddiskspaceper);
							$freediskspaceper = 100 - $useddiskspaceper ;
							$freediskspace = int($_[2]/1024);
							
							if ($_[2] != '-'){

									Wily::PrintMetric::printMetric( type        => 'IntCounter',
														resource    => 'OSResource-Linux|Disk',
															subresource => $mountedOn,
																name        => 'Free Disk Space (MB)',
																value       => $freediskspace,
														 );
										Wily::PrintMetric::printMetric( type        => 'IntCounter',
														resource    => 'OSResource-Linux|Disk',
															subresource => $mountedOn,
																name        => 'Free Disk Space (%)',
																value       => $freediskspaceper,
															);

							                 }

				 }
				
		 	}

		}

	close(DISK);
};

if ( $@ ) {
	# write the error message to an error log for troubleshooting
	open(ERROR_LOG,">>$error_log") || die "Error when opening file \"$error_log\": $!";
	print ERROR_LOG localtime() . " - " . $@;
	close(ERROR_LOG);

	# gives the end user the opportunity to monitor the vmstat plugin
	print qq{OSResource-Linux|Disk:Success=1\n};	
}
